---
title: URL()
slug: Web/API/URL/URL
tags:
  - API
  - Constructor
  - Reference
  - URL
  - URL API
---
<div>{{APIRef("URL API")}}</div>

<p>The <code><strong>URL()</strong></code> constructor returns a newly created {{domxref("URL")}} object representing the URL defined by the parameters.</p>

<p>If the given base URL or the resulting URL are not valid URLs, the JavaScript {{jsxref("TypeError")}} exception is thrown.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <var>url</var> = new URL(<var>url</var> [, <var>base</var>])
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><code><var>url</var></code></dt>
	<dd>A {{domxref("USVString")}} representing an absolute or relative URL. If <code><var>url</var></code> is a relative URL, <code><var>base</var></code> is required, and will be used as the base URL. If <code><var>url</var></code> is an absolute URL, a given <code><var>base</var></code> will be ignored.</dd>
	<dt><code><var>base</var></code> {{optional_inline}}</dt>
	<dd>A {{domxref("USVString")}} representing the base URL to use in cases where <code><var>url</var></code> is a relative URL. If not specified, it defaults to <code>undefined</code>.</dd>
</dl>

<div class="note">
<p><strong>Note</strong>: The <code>url</code> and <code>base</code> arguments will each be stringified from whatever value you pass, just like with other Web APIs that accept {{domxref("USVString")}}. In particular, you can use an existing {{domxref("URL")}} object for either argument, and it will stringify to the object's {{domxref("URL.href", "href")}} property.</p>
</div>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Exception</th>
			<th scope="col">Explanation</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{jsxref("TypeError")}}</td>
			<td><code><var>url</var></code> (in the case of absolute URLs) or <code><var>base</var></code> + <code><var>url</var></code> (in the case of relative URLs) is not a valid URL.</td>
		</tr>
	</tbody>
</table>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">// Base urls
let m = 'https://developer.mozilla.org';
let a = new URL("/", m);                                // =&gt; 'https://developer.mozilla.org/'
let b = new URL(m);                                     // =&gt; 'https://developer.mozilla.org/'

        new URL('en-US/docs', b);                      // =&gt; 'https://developer.mozilla.org/en-US/docs'
let d = new URL('/en-US/docs', b);                     // =&gt; 'https://developer.mozilla.org/en-US/docs'
        new URL('/en-US/docs', d);                     // =&gt; 'https://developer.mozilla.org/en-US/docs'
        new URL('/en-US/docs', a);                     // =&gt; 'https://developer.mozilla.org/en-US/docs'

        new URL('/en-US/docs', "https://developer.mozilla.org/fr-FR/toto");
                                                       // =&gt; 'https://developer.mozilla.org/en-US/docs'

        new URL('/en-US/docs', '');                    // Raises a TypeError exception as '' is not a valid URL
        new URL('/en-US/docs');                        // Raises a TypeError exception as '/en-US/docs' is not a valid URL
        new URL('http://www.example.com', );           // =&gt; 'http://www.example.com/'
        new URL('http://www.example.com', b);          // =&gt; 'http://www.example.com/'

        new URL("//foo.com", "https://example.com")    // =&gt; 'https://foo.com' (see relative URLs)
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('URL', '#constructors', 'URL.URL()')}}</td>
			<td>{{Spec2('URL')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.URL.URL")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>The interface it belongs to: {{domxref("URL")}}.</li>
</ul>
